using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace RFID
{
    /// <summary>
    /// GroupLab.Phidgets.RFIDgPhidgetRFIDkiteXgĂ݂
    /// </summary>
    public partial class PhidgetRFIDForm : Form
    {

        public PhidgetRFIDForm()
        {
            InitializeComponent();
            this.defaultText = this.Text; // Form̏^CgۑĂ
        }

        #region Properties and AccessorMethod
        private string defaultText; // Form̏^Cg

        private bool isAttaching = false;
        /// <summary>
        /// PhidgetRFIDڑĂ邩ǂ
        /// </summary>
        public bool Attaching
        {
            get
            {
                return this.isAttaching;
            }
            set
            {
                this.isAttaching = value;
                StringDataDelegate status_delegate = FormTextWrite;
                try
                {
                    if (value) this.Invoke(status_delegate, "Attaching"); // ڑ
                    else this.Invoke(status_delegate, "Deteching"); // ؒf
                }
                catch { }
            }
        }

        #endregion

        #region methods

        /// <summary>
        /// RFID[_ݒ
        /// </summary>
        public void rfid_init()
        {
            rfid.Outputs[0].State = false; // 5V output
            rfid.Outputs[1].State = false; // external LED
            rfid.Outputs[2].State = true; // on board LED
            rfid.Outputs[3].State = true; // active Reader
        }

        #endregion


        #region methods to control UI
        delegate void StringDataDelegate(string msg);

        /// <summary>
        /// messagetextboxLogConsoleɏo͂
        /// </summary>
        /// <param name="str">messageText</param>
        public void message_writeLine(string str)
        {
            Console.WriteLine(str);
            StringDataDelegate mes_delegate = MessageWrite; // ֐w肵Delegate쐬
            try
            {
                this.Invoke(mes_delegate, str); // FormƓXbhŎs
            }
            catch{ // O
                Console.WriteLine("thread error");
            }
        }

        /// <summary>
        /// textBoxLogɃbZ[W\ delegateoRŌĂяo
        /// </summary>
        /// <param name="str"></param>
        private void MessageWrite(string str)
        {
            textBoxLog.Text = str+"\r\n"+textBoxLog.Text;
        }

        /// <summary>
        /// this.Textɏԕ\ delegateoRŌĂяo
        /// </summary>
        /// <param name="str"></param>
        private void FormTextWrite(string statusStr)
        {
            this.Text = this.defaultText + ": " + statusStr; // Form̃^CgύX
        }
        #endregion


        #region Phidgets Event
        /// <summary>
        /// PhidgetRFID ڑꂽ
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void rfid1_Attach(object sender, EventArgs e)
        {
            rfid_init(); // RFIDݒ
            message_writeLine("PhidgetRFID: Attach - DeviceID:"+rfid.PhidgetDevice.SerialNumber);
            this.Attaching = true;
        }

        /// <summary>
        /// PhidgetRFID ڑꂽ
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void rfid1_Detach(object sender, EventArgs e)
        {
            message_writeLine("PhidgetRFID: Detech");
            this.Attaching = false;
        }

        /// <summary>
        /// PhidgetRFID G[N
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void rfid1_Error(object sender, GroupLab.Phidgets.PhidgetErrorEventArgs e)
        {
            message_writeLine("PhidgetRFID: Error");
            message_writeLine("  Device:" + e.PhidgetDevice + "Description:" + e.Description);
        }

        /// <summary>
        /// PhidgetRFID 悭킩Ȃ
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void rfid1_OutputChange(object sender, GroupLab.Phidgets.BitStateChangeEventArgs e)
        {
            //message_writeLine("PhidgetRFID: OutputChange");
        }

        /// <summary>
        /// PhidgetRFID ^Oǂݍ܂ꂽ
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void rfid1_Tag(object sender, GroupLab.Phidgets.RFIDTagEventArgs e)
        {
            message_writeLine("Tag: " + e.Tag);
        }

        #endregion

    }
}